#include <stdlib.h> 
#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <time.h>

#define fr2fi fr2fi_
#define mosstranscounts mosstranscounts_

#define frand() ((double)random()/(RAND_MAX+1.))

#define maxn 1024

extern struct fr2fi{
    float thfk[8*maxn],simul[8*maxn];            
} fr2fi;

void mosstranscounts(float *base, int *achannel, float *awin_fraction,
          float *abg_fraction, float *acountrate, float *adeadtime, 
          float *adwelltime, float *ameasuretime, float *aprint, int *iseed) 
{ 
    float tau,deadtime,lastevent,eventtime,mtime, *theo;
    double carlonu,totaltime,printmct,bg_fraction,dwelltime,inwindow; 
    int  nu_channel;
    long int ichannel,i,icount, *isimul; 
  time_t  t0, t1; /* time_t is defined on <time.h> and <sys/types.h> as long */
  clock_t c0, c1; /* clock_t is defined on <time.h> and <sys/types.h> as int */

    srandom(*iseed);
    nu_channel=*achannel;
    theo=   malloc(nu_channel * sizeof(float));
    isimul= malloc(nu_channel * sizeof(long int));
    for(i=0;i<nu_channel; i++) isimul[i]=0;
    for(i=0;i<nu_channel; i++) theo[i]=fr2fi.thfk[i];

    t0 = time(NULL);
    c0 = clock(); 
    mtime=0.;
      printf ("measure time:%6.1f sec.\n",*ameasuretime);
    inwindow=*awin_fraction;
    bg_fraction=*abg_fraction;
    tau=1000./ *acountrate*inwindow;
    deadtime=*adeadtime;
    dwelltime=*adwelltime;
    printmct=*aprint*4.e6*tau;

    icount=0;
    totaltime=0.;
    ichannel=0;
    lastevent=0.0;
    while(mtime < *ameasuretime){
       carlonu=frand();
       icount=icount+1;
       eventtime=-tau*log(1.-carlonu);
       ichannel=ichannel+eventtime/dwelltime+carlonu;
/*     in order to destroy channel/counts correlation (avoiding pattern)*/
       i=ichannel/nu_channel; ichannel=ichannel-i*nu_channel;
       totaltime=totaltime+eventtime;
       lastevent=lastevent+eventtime;
       if(lastevent > deadtime){
         icount=icount+1;
	 if(frand() < inwindow ){  
	   if(frand() < bg_fraction ){
	       icount=icount+1; isimul[ichannel]++;lastevent=0.0;}
           else
	       if(frand() <theo[ichannel]){icount=icount+1; 
           isimul[ichannel]++;lastevent=0.0;}
	   }else lastevent=0.0;
       }
       if(totaltime > printmct){
       c1 = clock();
       mtime=(float) (c1 - c0)/CLOCKS_PER_SEC;
       printf ("CPU time:%6.1f sec.    MC-calls=%d\n",mtime,icount);
       totaltime=0.;
        } 
  }
    for(i=0;i<nu_channel; i++) fr2fi.simul[i]=isimul[i];
    free( isimul);
    free(theo);              
}
