      real function arcos(h) 
      implicit none
      real  h,hh,pi2,s
                                                                  
      pi2=2.0*atan(1.0) 
      hh=h*h 
      if(hh.ge.1) then 
       arcos=0.0 
       if(h.lt.0.0) arcos=2.0*pi2 
      else 
       s=sqrt(1.0-hh) 
       if(abs(h).lt.0.0001) then 
        arcos=pi2 
       else 
        arcos=atan(s/h) 
        if(h.lt.0) arcos=2.0*pi2+arcos 
       end if 
      end if 
      return 
      END                                           
                                                                        
      subroutine uvector(cp132,uvec,info)
      use glbconst, only: nwr 
      implicit none                                                                  
      character(len=132):: cp132 
      real      h,uvec(3),out(32) 
      integer   info,i,il,ist,k,nn
                                                                 
       il=LEN_TRIM(cp132) 
       do k=2,il-1 
        if(cp132(k:k).eq.' ') then 
         do i=k,il-1 
          cp132(i:i)=cp132(i+1:i+1) 
         end do 
        end if 
       end do 
                                                                        
       ist=index(cp132,',*,') 
       if(ist.gt.0) then 
        cp132(ist:ist+2)='   ' 
        call trlch(il,cp132,nn,out) 
        if(nn.lt.2) then 
         write(nwr,'(a)') 'less than 2 components found for eax' 
         info=1
         return 
        end if 
        h=out(1)**2+out(2)**2 
        if(h.gt.1) then 
         h=sqrt(h) 
         out(1)=out(1)/h 
         out(2)=out(2)/h 
         out(3)=0.0 
        else 
         out(3)=sqrt(1.0-h) 
        end if 
        uvec(1)=out(1) 
        uvec(2)=out(3) 
        uvec(3)=out(2) 
        goto 100 
       end if 
                                                                        
       ist=index(cp132,'*,') 
       if(ist.gt.0) then 
        cp132(ist:ist+1)='   ' 
        call trlch(il,cp132,nn,out) 
        if(nn.lt.2) then 
         write(nwr,'(a)') 'less than 2 components found for eax' 
         info=1
         return 
        end if 
        h=out(1)**2+out(2)**2 
        if(h.gt.1) then 
         h=sqrt(h) 
         out(1)=out(1)/h 
         out(2)=out(2)/h 
         out(3)=0.0 
        else 
         out(3)=sqrt(1.0-h) 
        end if 
        uvec(1)=out(3) 
        uvec(2)=out(1) 
        uvec(3)=out(2) 
        goto 100 
       end if 
                                                                        
       ist=index(cp132,',*') 
       if(ist.gt.0) then 
        cp132(ist:ist+1)='   ' 
        call trlch(il,cp132,nn,out) 
        if(nn.lt.2) then 
         write(nwr,'(a)') 'less than 2 components found for eax' 
         info=1
         return 
        end if 
        h=out(1)**2+out(2)**2 
        if(h.gt.1) then 
         h=sqrt(h) 
         out(1)=out(1)/h 
         out(2)=out(2)/h 
         out(3)=0.0 
        else 
         out(3)=sqrt(1.0-h) 
        end if 
        uvec(1)=out(1) 
        uvec(2)=out(2) 
        uvec(3)=out(3) 
        goto 100 
       end if 
                                                                        
       call trlch(il,cp132,nn,out) 
       uvec(1)=out(1) 
       uvec(2)=out(2) 
       uvec(3)=out(3) 
                                                                        
  100 continue 
      return 
      END                                           
                                                                        
      subroutine crospr(uvec1,uvec2,uvec3) 
      implicit none

      real     uvec1(3),uvec2(3),uvec3(3),h 
      integer  k                                                                  
      uvec3(1)= uvec1(2)*uvec2(3)-uvec1(3)*uvec2(2) 
      uvec3(2)=-uvec1(1)*uvec2(3)+uvec1(3)*uvec2(1) 
      uvec3(3)= uvec1(1)*uvec2(2)-uvec1(2)*uvec2(1) 
      h=0.0 
      do k=1,3 
       h=h+ uvec3(k)**2 
      end do 
      h=sqrt(h) 
      do k=1,3 
       uvec3(k)=uvec3(k)/h 
      end do 
!      write(6,'(3f12.3)')(uvec1(k),k=1,3)                              
!      write(6,'(3f12.3)')(uvec2(k),k=1,3)                              
!      write(6,'(3f12.3)')(uvec3(k),k=1,3)                              
      return 
      END                                           
                                                                        
       subroutine euler_omega(ax_theta,ax_phi,omega,oalpha,obeta,ogamma,&
                              alpha,beta,gamma,thickness,case,info)     
       use glbconst, only: infotext,enwr,nwr
       implicit none
       integer case,info 
       real        ax_theta,ax_phi,omega,oalpha,obeta,ogamma,alpha,beta,&
                   gamma,thickness  
       real        uveca(3,3),uvecb(3,3),uvec(3,3) 
       complex     drt(-1:1,-1:1) 
       real, parameter:: pi=3.141592654,rad=0.017453293 
       character(len=6),dimension(3):: eai,ebi
       character(len=8),dimension(3):: text
       logical     b_error 
       integer     i,l,m,k 
       real        cosb,cosg,cosa,dx,dy,dz,h,omcosg,              & 
                   sina,sinb,sing,st,xalpha,xbeta,xgamma,arcos  
!       write(6,'(a,3f10.1)')' alpha,beta,gamma=',oalpha,obeta,ogamma   
!      oalpha,obeta,ogamma is the transformation of the crystal system t
!      absorber system.                                                 
!      omega rotation around the axis ax_theta,ax_phi in the absorbersys
                                                                        
!      inverse matrix uveca  
       call dimj(oalpha*rad,obeta*rad,ogamma*rad,1,drt)
                                                                        
       uveca(1,1)=0.5*real(drt(1,1)-drt(-1,1)-drt(1,-1)+drt(-1,-1)) 
       uveca(1,2)=-0.5*aimag(drt(1,1)+drt(-1,1)-drt(1,-1)-drt(-1,-1)) 
       uveca(1,3)=-1./sqrt(2.)*real(drt(0,1)-drt(0,-1)) 
                                                                        
       uveca(2,1)=0.5*aimag(drt(1,1)-drt(-1,1)+drt(1,-1)-drt(-1,-1)) 
       uveca(2,2)=0.5*real(drt(1,1)+drt(-1,1)+drt(1,-1)+drt(-1,-1)) 
       uveca(2,3)=-1./sqrt(2.)*aimag(drt(0,1)+drt(0,-1)) 
                                                                        
       uveca(3,1)=-1./sqrt(2.)*real(drt(1,0)-drt(-1,0)) 
       uveca(3,2)=1./sqrt(2.)*aimag(drt(1,0)+drt(-1,0)) 
       uveca(3,3)=real(drt(0,0)) 
                                                                        
                                                                        
       xalpha=ax_phi*rad 
       xbeta=ax_theta*rad 
       xgamma=omega*rad 
                                                                        
       cosa=cos(xalpha) 
       sina=sin(xalpha) 
       cosb=cos(xbeta) 
       sinb=sin(xbeta) 
                                                                        
       cosg=cos(xgamma) 
       sing=sin(xgamma) 
       omcosg=1.0-cosg 
                                                                        
       dx=sinb*cosa 
       dy=sinb*sina 
       dz=cosb 
                                                                        
                                                                        
       uvecb(1,1)=dx**2*omcosg +cosg 
       uvecb(1,2)=dx*dy*omcosg+dz*sing 
       uvecb(1,3)=dx*dz*omcosg-dy*sing 
                                                                        
       uvecb(2,1)=dx*dy*omcosg-dz*sing 
       uvecb(2,2)=dy**2*omcosg+cosg 
       uvecb(2,3)=dz*dy*omcosg+dx*sing 
                                                                        
       uvecb(3,1)=dx*dz*omcosg+dy*sing 
       uvecb(3,2)=dy*dz*omcosg-dx*sing 
       uvecb(3,3)=dz**2*omcosg+cosg  
                                                                        
                                                                        
                                                                        
       do l=1,3 
       do m=1,3 
        h=0. 
        do i=1,3 
         h=h+uveca(l,i)*uvecb(i,m) 
        end do 
        uvec(l,m)=h 
       end do 
       end do 
       do l=1,3 
       do m=1,3 
        uvecb(l,m)=uvec(l,m) 
        uveca(l,m)=0. 
       end do 
         uveca(l,l)=1. 
       end do 
                                                                        
       b_error=.false. 
       if(case.eq.3)then 
!       1. case: Rotation axis (defined with respect to the lab. system 
!               is the g-direction) is normal to the surface of the samp
!               The thickness of the sample increases by the factor 1/co
!       2. case: rotation axis lies in the sample plane (ax_theta=90°) 
!               The sample is rotated out of the position orthonormal to
!               g-direction by the rotation angle omega. The thickness o
!               sample increases by the factor 1/cos(omega)             
!       Which case is decided by theta<90°.                            
        b_error=.true. 
        if(abs(ax_theta-90).lt.0.01) then 
         if(cosg.gt.0.05)then 
          thickness=1./cosg 
          b_error=.false. 
         end if 
        else 
         if(cosb.gt.0.05)then 
          thickness=1./cosb 
          b_error=.false. 
         end if 
        end if 
        if(b_error)then 
         info=1
         infotext(1)='<euler>/sample/rotation/axis' 
         infotext(2)(1:17)=' Rotation axis is ill defined' 
         infotext(3)=' ' 
         goto 10 
        end if 
       end if 
                                                                        
!      vectors uveca and uvecb are known                                
!      calculation of Euler angle alpha,beta,gamma                      
                                                                        
       h=0.0 
       do k=1,3 
        h=h+uveca(3,k)*uvecb(3,k) 
       end do 
       beta=arcos(h) 
       st=sin(beta) 
       if(beta.lt.0.001) then 
        beta=0.0 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(1,k) 
        end do 
        alpha=arcos(h) 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(2,k) 
        end do 
        if(h.gt.0.0) alpha=2.0*pi-alpha 
        gamma=0.0 
        ! beta=0                                                   
       else    ! sin(beta)=0  
        if(abs(st).lt.0.001) then 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(1,k) 
         end do 
         gamma=0.0 
         alpha=arcos(-h) 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(2,k) 
         end do 
         if(h.gt.0.0) alpha=2.0*pi-alpha 
        else 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(3,k) 
         end do 
         alpha=arcos(h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(2,k)*uvecb(3,k) 
         end do 
         if(h.lt.0.0) alpha=2.0*pi-alpha 
                                                                        
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(1,k) 
         end do 
         gamma=arcos(-h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(2,k) 
         end do 
        if(h.lt.0.0) gamma=2.0*pi-gamma 
        end if  ! sin(beta)#0   
       end if   ! beta=0  
       beta=beta/rad 
       alpha=alpha/rad 
       gamma=gamma/rad 
                                                                        
!       write(nwr,'(/,a)') 'unit vectors of system Sb in system S'      
!      caution! vector a is the transpose matrix in order to print the  
!      unit vectors of the rotatet system in the original system.       

   10 if(enwr(7).eq.'eulr'.or.b_error) then 
       write(nwr,'(/,a,/,3(a,f10.2),/)')                                &
                    ' unit vectors of system Sa and system Sb',         &
       ' ax_theta=',ax_theta,' ax_phi=',ax_phi,' omega=',omega          
                                                                        
       eai(1)='      x' 
       eai(2)='e_C = y' 
       eai(3)='      z' 
       ebi(1)='      x' 
       ebi(2)='r_ax= y' 
       ebi(3)='      z' 
       text(1)=' in the  ' 
       text(2)=' Lab.    ' 
       text(3)=' system  ' 
                                                                        
        do k=1,3 
         write(nwr,'(a12,x,2(a6,a3,3(f7.3,a1),3x))') text(k),           &
         eai(k),' ( ',uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'      
        end do 
                                                                        
        write(nwr,'(/,20x,a,/,a,3(f6.1,a),/)')                          &
        'Euler angles alpha,beta,gamma',                                &
         ' eb(n)=Sum;m ea(m) D1,mn(alpha=',                             &
         alpha,',beta=',beta,',gamma=',gamma,')'                       
        if(b_error) return 
       end if 
       return 
      END                                           
                                                                        
       subroutine  euler_dir(x_theta,x_phi,z_theta,z_phi,               &
                             alpha,beta,gamma,thickness,info)          
       use glbconst, only: enwr,nwr
       implicit none
       integer    info,k
       real       x_theta,x_phi,z_theta,z_phi,alpha,beta,gamma,         &
                  thickness                                                     
       real       uveca(3,3),uvecb(3,3),uvec1(3),uvec2(3),uvec3(3) 
                                                                        
       character(len=6),dimension(3):: eai,ebi  
       logical     b_error 
       real        st,ax_phi,ax_theta,omega,h,arcos
       real, parameter:: pi=3.141592654,rad=0.017453293 

         st=sin(x_theta*rad) 
         uvecb(1,1)=st*cos(x_phi*rad) 
         uvecb(1,2)=st*sin(x_phi*rad) 
         uvecb(1,3)=cos(x_theta*rad) 
                                                                        
                                                                        
         st=sin(z_theta*rad) 
         uvecb(3,1)=st*cos(z_phi*rad) 
         uvecb(3,2)=st*sin(z_phi*rad) 
         uvecb(3,3)=cos(z_theta*rad) 
                                                                        
!       zeta=arcos(uvecb(3,3)) is the angle between old and new z-axes  
!       1/ uvecb(3,3)> 1 is the increase of the thickness of the        
!       absorber with respect to the  g-direction parallel to the old z-
       b_error=.false. 
       thickness=1./abs(uvecb(3,3)) 
       if(thickness.gt.100) then 
        write(nwr,'(a)')' orientation of the scatterer is such that',   &
     &  ' the z-axis lies in the plan of the scatterer'                 
        b_error=.true.
        info=1 
       end if 
                                                                        
         do k=1,3 
          uvec1(k)=uvecb(3,k) 
          uvec2(k)=uvecb(1,k) 
         end do 
         call crospr(uvec1,uvec2,uvec3) 
         do k=1,3 
          uvecb(2,k)=uvec3(k) 
         end do 
                                                                        
!      calculation of Euler angle alpha,beta,gamma                      
                                                                        
       beta=arcos(uvecb(3,3)) 
       st=sin(beta) 
       if(beta.lt.0.001) then 
        beta=0.0 
        beta=beta/rad 
        alpha=arcos(uvecb(1,1)) 
        h=uvecb(2,1) 
        if(h.gt.0.0) alpha=2.0*pi-alpha 
        gamma=0.0 
             ! beta=0                                                   
       else 
                                   ! sin(beta)=0                        
        if(abs(st).lt.0.001) then 
         h=uvecb(1,1) 
         gamma=0.0 
         alpha=arcos(-h) 
         h=uvecb(2,1) 
         if(h.gt.0.0) alpha=2.0*pi-alpha 
        else 
         h=uvecb(3,1) 
         alpha=arcos(h/st) 
         h=uvecb(3,2) 
         if(h.lt.0.0) alpha=2.0*pi-alpha 
         h=uvecb(1,3) 
         gamma=arcos(-h/st) 
         h=uvecb(2,3) 
        if(h.lt.0.0) gamma=2.0*pi-gamma 
               ! sin(beta)#0                                            
       end if 
               ! beta=0                                                 
       end if 
       beta=beta/rad 
       alpha=alpha/rad 
       gamma=gamma/rad 
                                                                        
      if(enwr(7).eq.'eulr') then 
                                                                        
       write(nwr,'(/,a,/,3(a,f10.2))')                                  &
                    ' unit vectors of system Sb in system S',           &
       ' ax_theta=',ax_theta,' ax_phi=',ax_phi,' omega=',omega          
       eai(1)='eax' 
       eai(2)='eay' 
       eai(3)='eaz' 
       ebi(1)='ebx' 
       ebi(2)='eby' 
       ebi(3)='ebz' 
       do k=1,3 
        write(nwr,'(6x,a3,a2,3(f8.3,a1))')ebi(k),'=(',                  &
                  uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'          
       end do 
                                                                        
       write(nwr,'(/,a)') 'unit vectors of system Sa in system S' 
       do k=1,3 
        write(nwr,'(6x,a3,a2,3(f8.3,a1))')eai(k),'=(',                  &
                  uveca(k,1),',',uveca(k,2),',',uveca(k,3),')'          
       end do 
                                                                        
       write(nwr,'(/,20x,a,/,a,3(f6.1,a),/)')                           &
       'Euler angles alpha,beta,gamma',                                 &
       'eb(n)=Sum;m ea(m) D1,mn(alpha=',                                &
          alpha,',beta=',beta,',gamma=',gamma,')'                       
                                                                        
       if(b_error) return 
      end if 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
       subroutine euler_omega2(ax_theta,ax_phi,omega,                   &
                               ax_theta2,ax_phi2,omega2,                &
                              alpha,beta,gamma )                        
       use glbconst, only: nwr 
       implicit none
       real       ax_theta,ax_phi,omega,ax_theta2,ax_phi2,omega2,       &
                  alpha,beta,gamma                                                                        
       real       uveca(3,3),uvecb(3,3),uvec(3,3) 
       character(len=6),dimension(3):: eai,ebi
       character(len=8),dimension(3):: text
       integer    i,k,l,m
       real       cosa,cosb,cosg,dx,dy,dz,h,omcosg,sina,sinb,sing,st,   &
                  xalpha,xbeta,xgamma,arcos
       real, parameter:: pi=3.141592654,rad=0.017453293 
                                                                
       xalpha=ax_phi2*rad 
       xbeta=ax_theta2*rad 
       xgamma=omega2*rad 
                                                                        
       cosa=cos(xalpha) 
       sina=sin(xalpha) 
       cosb=cos(xbeta) 
       sinb=sin(xbeta) 
                                                                        
       cosg=cos(xgamma) 
       sing=sin(xgamma) 
       omcosg=1.0-cosg 
                                                                        
       dx=sinb*cosa 
       dy=sinb*sina 
       dz=cosb 
                                                                        
       uveca(1,1)=dx**2*omcosg +cosg 
       uveca(1,2)=dx*dy*omcosg+dz*sing 
       uveca(1,3)=dx*dz*omcosg-dy*sing 
                                                                        
       uveca(2,1)=dx*dy*omcosg-dz*sing 
       uveca(2,2)=dy**2*omcosg+cosg 
       uveca(2,3)=dz*dy*omcosg+dx*sing 
                                                                        
       uveca(3,1)=dx*dz*omcosg+dy*sing 
       uveca(3,2)=dy*dz*omcosg-dx*sing 
       uveca(3,3)=dz**2*omcosg+cosg 
                                                                        
                                                                        
                                                                        
       xalpha=ax_phi*rad 
       xbeta=ax_theta*rad 
       xgamma=omega*rad 
                                                                        
       cosa=cos(xalpha) 
       sina=sin(xalpha) 
       cosb=cos(xbeta) 
       sinb=sin(xbeta) 
                                                                        
       cosg=cos(xgamma) 
       sing=sin(xgamma) 
       omcosg=1.0-cosg 
                                                                        
       dx=sinb*cosa 
       dy=sinb*sina 
       dz=cosb 
                                                                        
       uvecb(1,1)=dx**2*omcosg +cosg 
       uvecb(1,2)=dx*dy*omcosg+dz*sing 
       uvecb(1,3)=dx*dz*omcosg-dy*sing 
                                                                        
       uvecb(2,1)=dx*dy*omcosg-dz*sing 
       uvecb(2,2)=dy**2*omcosg+cosg 
       uvecb(2,3)=dz*dy*omcosg+dx*sing 
                                                                        
       uvecb(3,1)=dx*dz*omcosg+dy*sing 
       uvecb(3,2)=dy*dz*omcosg-dx*sing 
       uvecb(3,3)=dz**2*omcosg+cosg 
                                                                        
       do l=1,3 
       do m=1,3 
        h=0. 
        do i=1,3 
         h=h+uvecb(l,i)*uveca(i,m) 
        end do 
        uvec(l,m)=h 
       end do 
       end do 
       do l=1,3 
       do m=1,3 
        uvecb(l,m)=uvec(l,m) 
       end do 
       end do 
                                                                        
       do l=1,3 
       do m=1,3 
        uvec(l,m)=uveca(l,m) 
        uveca(l,m)=0. 
       end do 
         uveca(l,l)=1. 
       end do 
                                                                        
!      vectors uveca and uvecb are known                                
!      calculation of Euler angle alpha,beta,gamma                      
                                                                        
       h=0.0 
       do k=1,3 
        h=h+uveca(3,k)*uvecb(3,k) 
       end do 
       beta=arcos(h) 
       st=sin(beta) 
       if(beta.lt.0.001) then 
        beta=0.0 
        beta=beta/rad 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(1,k) 
        end do 
        alpha=arcos(h) 
        h=0.0 
        do k=1,3 
         h=h+uveca(1,k)*uvecb(2,k) 
        end do 
        if(h.gt.0.0) alpha=2.0*pi-alpha 
        gamma=0.0 
             ! beta=0                                                   
       else 
                                   ! sin(beta)=0                        
        if(abs(st).lt.0.001) then 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(1,k) 
         end do 
         gamma=0.0 
         alpha=arcos(-h) 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(2,k) 
         end do 
         if(h.gt.0.0) alpha=2.0*pi-alpha 
        else 
         h=0.0 
         do k=1,3 
          h=h+uveca(1,k)*uvecb(3,k) 
         end do 
         alpha=arcos(h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(2,k)*uvecb(3,k) 
         end do 
         if(h.lt.0.0) alpha=2.0*pi-alpha 
                                                                        
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(1,k) 
         end do 
         gamma=arcos(-h/st) 
         h=0.0 
         do k=1,3 
          h=h+uveca(3,k)*uvecb(2,k) 
         end do 
        if(h.lt.0.0) gamma=2.0*pi-gamma 
               ! sin(beta)#0                                            
       end if 
               ! beta=0                                                 
       end if 
       beta=beta/rad 
       alpha=alpha/rad 
       gamma=gamma/rad 
                                                                        
      eai(1)='     x' 
      eai(2)='e1 = y' 
      eai(3)='     z' 
      ebi(1)='     x' 
      ebi(2)='e21= y' 
      ebi(3)='     z' 
      text(1)='        ' 
      text(2)='        ' 
      text(3)='        ' 
!       write(nwr,'(/,a)') 'unit vectors of system Sb in system S'      
!      caution! vector a is the transpose matrix in order to print the  
!      unit vectors of the rotatet system in the original system.       
                                                                        
       do k=1,3 
        write(nwr,'(a8,x,2(a6,a3,3(f7.3,a1),3x))') text(k),             &
     &  eai(k),' ( ',uvec(k,1),',',uvec(k,2),',',uvec(k,3),')',         &
     &  ebi(k),' ( ',uvecb(k,1),',',uvecb(k,2),',',uvecb(k,3),')'       
       end do 
       write(nwr,'(a)') 
                                                                        
       write(nwr,'(/,20x,a,/,a,3(f6.1,a),/)')                           &
     & 'Euler angles alpha,beta,gamma',                                 &
     & 'eb(n)=Sum;m ea(m) D1,mn(alpha=',                                &
     &    alpha,',beta=',beta,',gamma=',gamma,')'                       
                                                                        
        return 
      END                                           
                                                                        

      subroutine exyz(phi,theta,psi,invers,nwr) 
      implicit none 
      integer invers,m,n,nwr 
      real    phi,theta,psi,hx,hy,hz
      complex djv(-1:1,-1:1),ev(-1:1),evt(-1:1),hc1 
                                                                        
       if(invers.eq.-1) then 
        call dimj(-psi,-theta,-phi,1,djv) 
       else 
        call dimj(phi,theta,psi,1,djv)
       end if 
                                                                        
       ev(1)=-cmplx(1,0)/sqrt(2.) 
       ev(0)=(0.,0.) 
       ev(-1)=-conjg(ev(1)) 
       do n=-1,1 
        hc1=(0.,0.) 
        do m=-1,1 
         hc1=hc1+ev(m)*djv(m,n) 
        end do 
        evt(n)=hc1 
       end do 
       hx=-real(evt(1)-evt(-1))/sqrt(2.0) 
       hy= real((evt(1)+evt(-1))*cmplx(0.,1.))/sqrt(2.0) 
       hz= real(evt(0)) 
       write(nwr,'(a,3f8.3,a1)') ' ex= (',hx,hy,hz,')' 
                                                                        
       ev(1)=-cmplx(0,1)/sqrt(2.) 
       ev(0)=(0.,0.) 
       ev(-1)=-conjg(ev(1)) 
       do n=-1,1 
        hc1=(0.,0.) 
        do m=-1,1 
         hc1=hc1+ev(m)*djv(m,n) 
        end do 
        evt(n)=hc1 
       end do 
       hx=-real(evt(1)-evt(-1))/sqrt(2.0) 
       hy= real((evt(1)+evt(-1))*cmplx(0.,1.))/sqrt(2.0) 
       hz= real(evt(0)) 
       write(nwr,'(a,3f8.3,a1)') ' ey= (',hx,hy,hz,')' 
                                                                        
       ev(1)=(0.,0.) 
       ev(0)=(1.,0.) 
       ev(-1)=-conjg(ev(1)) 
       do n=-1,1 
        hc1=(0.,0.) 
        do m=-1,1 
         hc1=hc1+ev(m)*djv(m,n) 
        end do 
        evt(n)=hc1 
       end do 
       hx=-real(evt(1)-evt(-1))/sqrt(2.0) 
       hy= real((evt(1)+evt(-1))*cmplx(0.,1.))/sqrt(2.0) 
       hz= real(evt(0)) 
       write(nwr,'(a,3f8.3,a1)') ' ez= (',hx,hy,hz,')' 
                                                                        
       return 
      END                                           
