      subroutine thstr_hdeq(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
                                                                        
!     hyperfine parameters of H(j),DEQ(j), equivalent sites             
!     for n_ik(E) refraction index (static)                             
!     level 3 theory                                                    
                                                                        
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth
      character(len=4)  :: cova

      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='22ref.index(stat)-H DEQ' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='H(S_E),DEQ, equivalent sites' 
       namepg(1)='H_DEQ_equivalent_sites  plrs,1 ' 
       nameth(2)='H(S_C),DEQ, equivalent sites' 
       namepg(2)='H_DEQ_equivalent_sites  plrs,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='2x2 refraction index (static,sad)' 
       ntheory(2)='2x2 refraction index (static)' 
       ntheory(3)='2x2 rho-source (strength,LORGAU)' 
       ntheory(4)='2x2 rho-source selfabsorption (Delta distr)'
       ntheory(5)='2x2 rho-source selfabsorption (constant distr)'
       ntheory(6)='2x2 rho-source selfabsorption (diffusion profile)'
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(6))l_jth=2 
       return 
      end if 
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=5  chth='//chth 
!      list=5 introduces  8 constants                                 
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
      thco(jc+1)='sym_case    i_pos=1    include=y   0' 
               ! equivalent sites by rotation around the z-axis         
      thco(jc+2)='time_invers  i_pos=2   include=y   0' 
               ! equivalent sites by rotation around the y-axis         
      jc=jc+2 
                                                                        
!      common/avsstrf/avss,                                             
!                      sftr,aisom,w_Gauss,w_Lorentz                     
!     &                sx2zz,sx2eta,sx2phi,sx2theta,sx2psi,             
!     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE          
                                                                        
                                                                        
!                    123456789012345678901234567                        
      ntrmt(jm+1)='H_internal  matrix=(3,3)   include=[n] ' 
      ctrmt(jm+1)='internal magnetic field at crystal site' 
       thpa(jp+1)='Hi               , 333.0  0.0 0.0  1.0' 
       thpa(jp+2)='thetaH           , 0.0 0.0 0.0   1.0' 
       thpa(jp+3)='phiH             , 0.0 0.0 0.0   1.0 ' 
       thvr(jv+1)='Hi                      1    1 0 0  ' 
       thvr(jv+2)='thetaH                  2    0 1 0 ' 
       thvr(jv+3)='phiH                    3    0 0 1' 
                                                                        
      ntrmt(jm+2)='EFG   matrix=(2,2)   include=[n] ' 
      ctrmt(jm+2)='electric field gradient tensor at crystal site' 
       thpa(jp+4)='EFG              , 0.0  0.0 0.0  0.1' 
       thpa(jp+5)='eta              , 0.0  0.0 0.0  0.1' 
       thvr(jv+4)='EFG                     4    1 0 ' 
       thvr(jv+5)='eta                     5     0 1 ' 
                                                                        
      ntrmt(jm+3)='orient_EFG   matrix=(3,3)   include=[n] ' 
      ctrmt(jm+3)='Euler angle of the EFG in the crystal system' 
       thpa(jp+6)='phiE            , 0.0  0.0 0.0  1.0' 
       thpa(jp+7)='thetaE          , 0.0 0.0 0.0   1.0' 
       thpa(jp+8)='psiE            , 0.0 0.0 0.0   1.0 ' 
       thvr(jv+6)='phiE                    6   1 0 0' 
       thvr(jv+7)='thetaE                  7   0 1 0' 
       thvr(jv+8)='psiE                    8   0 0 1 ' 
      jm=jm+3 
      jp=jp+8 
      jv=jv+8 
      cova='10_8'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           
                                                                        
                                                                        
      subroutine thstr_hdeqf(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
                                                                        
!     hyperfine parameters of H(j),DEQ(j), equivalent sites             
!     for n_ik(E) refraction index (static),                            
!     powder,texture and external field                                 
!     level 3 theory                                                    
                                                                        
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8)  :: chth 
      character(len=4)  :: cova

      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='22ref.index(stat)-H DEQ f' 
!      names for child theories , mthchild=2 <= max_nth                 
       nameth(1)='H(S_E),DEQ,f(S_C), equiv. sites'  ! H in S_efg 
       namepg(1)='H_DEQ_f_equivalent_sites  plrs,1 ' 
       nameth(2)='H(S_C),DEQ,f(S_C), equiv. sites'  ! H in S_C
       namepg(2)='H_DEQ_f_equivalent_sites  plrs,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='2x2 refraction index (static,f_anisotrop,sad)' 
       ntheory(2)='2x2 refraction index (static)' 
       ntheory(3)='2x2 refraction index (Lwidth,f_anisotrop,sad)'
       ntheory(4)='2x2 refraction index (static,f_anisotrop)' 
       ntheory(5)='2x2 refraction index (Lwidth,f_anisotrop)' 
       ntheory(6)='2x2 rho-source (strength,LORGAU)'
       ntheory(7)='2x2 rho-source selfabsorption (Delta distr)' 
       ntheory(8)='2x2 rho-source selfabsorption (constant distr)' 
       ntheory(9)='2x2 rho-source selfabsorption (diffusion profile)' 
                                                                       
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(9)) l_jth=2
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=5  chth='//chth 
!      8 constants from list=5                                          
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       thco(jc+1)='sym_case  i_pos=1    include=y   0' 
               ! equivalent sites by rotation around the z-axis         
       thco(jc+2)='time_invers  i_pos=2 include=y   0' 
               ! equivalent sites by rotation around the y-axis         
       jc=jc+2 
                                                                        
!      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,                
!                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,              
!     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE          
!                     123456789012345678901234567                       
       ntrmt(jm+1)='x2sanisotropy  matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='mean square <x2> at the site' 
        thpa(jp+1)='dsx2                  ,  0.0  0.0 0.0  0.1' 
        thpa(jp+2)='x2seta                ,  0.0  0.0 0.0  0.1' 
        thvr(jv+1)='dsx2                     1    1 0  ' 
        thvr(jv+2)='x2seta                   2    0 1  ' 
                                                                        
       ntrmt(jm+2)='x2sorientation  matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='<x2> orientation with respect to S_C for' 
        thpa(jp+3)='x2sphi                , 0.0  0.0 0.0  1.0' 
        thpa(jp+4)='x2stheta              , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='x2spsi                , 0.0  0.0 0.0  1.0' 
        thvr(jv+3)='x2sphi                   3    1 0 0 ' 
        thvr(jv+4)='x2stheta                 4    0 1 0 ' 
        thvr(jv+5)='x2spsi                   5    0 0 1 ' 
                                                                        
       ntrmt(jm+3)='H_internal  matrix=(3,3)   include=[n]' 
       ctrmt(jm+3)='internal magnetic field at crystal site' 
        thpa(jp+6)='Hi               , 333.0  0.0 0.0  1.0' 
        thpa(jp+7)='thetaH           , 0.0 0.0 0.0   1.0' 
        thpa(jp+8)='phiH             , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+6)='Hi                       6    1 0 0  ' 
        thvr(jv+7)='thetaH                   7    0 1 0 ' 
        thvr(jv+8)='phiH                     8    0 0 1' 
       jm=jm+3 
       jp=jp+8 
       jv=jv+8 
       ntrmt(jm+1)='EFG    matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='electric field gradient tensor at crystal site' 
        thpa(jp+1)='EFG              , 0.0  0.0 0.0  0.1' 
        thpa(jp+2)='eta              , 0.0  0.0 0.0  0.1' 
        thvr(jv+1)='EFG                      9     1 0 ' 
        thvr(jv+2)='eta                      10    0 1 ' 
                                                                        
       ntrmt(jm+2)='orient_EFG    matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='Euler angle of the EFG in the crystal system' 
        thpa(jp+3)='phiE            , 0.0  0.0 0.0  1.0' 
        thpa(jp+4)='thetaE          , 0.0 0.0 0.0   1.0' 
        thpa(jp+5)='psiE            , 0.0 0.0 0.0   1.0 ' 
        thvr(jv+3)='phiE                    11   1 0 0' 
        thvr(jv+4)='thetaE                  12   0 1 0' 
        thvr(jv+5)='psiE                    13   0 0 1' 
       jm=jm+2 
       jp=jp+5 
       jv=jv+5 
       cova='1013'
       call convarmatpar(cova,jc,jv,jm,jp,chth) 
                                                                        
      return 
      END                                           
                                                                        
                                                                        
      subroutine thstr_hyperfineft(l_jth,cmch,nhelpentry) 
      use comstr,only: nameth,namepg,ntheory,nstruct,thco,ntrmt,ctrmt,thpa,thvr
      implicit none
                                                                        
!     hyperfine parameters of H(j),DEQ(j), equivalent sites             
!     for n_ik(E) refraction index (static),                            
!     powder,texture and external field                                 
!     level 3 theory                                                    
      integer,intent(out):: l_jth
      character(len=4),   intent(in)  :: cmch
      character(len=132),intent(inout):: nhelpentry
 
      character(len=8) :: chth 
      character(len=4) :: cova
 
      integer   jc,jv,jm,jp 
      logical   name_eq_ntheo 
                                                                        
      if(cmch.eq.'name')then 
       nhelpentry='2x2_index_f_spinham' 
                                                                        
!      names for child theories , mthchild=2 <= max_nth                 
                                           !  in S_C                    
       nameth(1)='DEQ spin Hamiltonian' 
       namepg(1)='DEQ_H_spinham_equiv_sites plrs,1 ' 
                                                       !  in S_C        
       nameth(2)='DEQ spin Hamiltonian, 2 hyp_fields' 
       namepg(2)='DEQ_H_spinham_equiv_sites plrs,2 ' 
       return 
      else if(cmch.eq.'theo') then 
!      look for mthchild theory fitting to ntheory,mthparent=2 <=max_nth
       ntheory(1)='2x2 refraction index (f,t,spinham,sad)' 
       ntheory(2)='2x2 refraction index (f,t,spinham)' 
                                                                        
!      if(name_eq_ntheo(mthparent))l_jth=mthchild                       
       if(name_eq_ntheo(2))l_jth=2 
       return 
      end if 
                                                                        
      chth='th'//nhelpentry(1:6) 
                                                                        
      if(cmch.eq.'hdbk') then 
       nstruct='handbook=nucleus.hdb   list=5  chth='//chth 
!      8 constants from list=5                                          
       return 
      end if 
                                                                        
      call convarmatpar('coll',jc,jv,jm,jp,chth) 
                                                                        
       thco(jc+1)='sym_case  i_pos=1    include=y   0' 
               ! equivalent sites by rotation around the z-axis         
       jc=jc+1 
                                                                        
!      common/avsstrf/avss,sftr,aisom,w_Gauss,w_Lorentz,                
!                      dsx2,sx2eta,sx2phi,sx2theta,sx2psi,              
!     &                aH,thetaH,phiH,DEq,eta,phiE,thetaE,psiE          
                                                                        
       ntrmt(jm+1)='x2sanisotropy    matrix=(2,2)   include=[n]' 
       ctrmt(jm+1)='mean square <x2> at the site' 
        thpa(jp+1)='dsx2                  ,  0.0  0.0 0.0  0.1' 
        thpa(jp+2)='x2seta                ,  0.0  0.0 0.0  0.1' 
        thvr(jv+1)='dsx2                     1    1 0  ' 
        thvr(jv+2)='x2seta                   2    0 1  ' 
                                                                        
       ntrmt(jm+2)='x2sorientation   matrix=(3,3)   include=[n]' 
       ctrmt(jm+2)='<x2> orientation with respect to S_C for' 
        thpa(jp+3)='x2sphi                , 0.0  0.0 0.0  1.0' 
        thpa(jp+4)='x2stheta              , 0.0  0.0 0.0  1.0' 
        thpa(jp+5)='x2spsi                , 0.0  0.0 0.0  1.0' 
        thvr(jv+3)='x2sphi                   3    1 0 0 ' 
        thvr(jv+4)='x2stheta                 4    0 1 0 ' 
        thvr(jv+5)='x2spsi                   5    0 0 1 ' 
       jm=jm+2 
       jp=jp+5 
       jv=jv+5 
       cova='_9_5'
      call convarmatpar(cova,jc,jv,jm,jp,chth) 
      return 
      END                                           
