      subroutine LORGAU(gamnat,e_xsi,srw8,w_Lorentz,w_Gauss,&
                                              iflag_Voigt,ipos,nLG)
      use glbconst, only: maxscrd
      use comthe, only: mLG,mGa,array_fr
      implicit none 
!     version August 2013
!     calculation of the Lorentz-Gauss functions                        
      real,    intent(in) :: gamnat,e_xsi,srw8,w_Lorentz,w_Gauss 
      integer, intent(in) :: nLG,iflag_Voigt,ipos
                                                                        
      complex  aLOR
      real     Gauss,dumscrd
      integer, parameter:: idumscrd=maxscrd-(mLG+mGa+1)*2-(mGa+2) 
      common/scrd/aLOR(0:mLG+mGa),Gauss(0:mGa+1),dumscrd(idumscrd) 
!                 aLOR and Gauss is only used in case of iflag_Voigt=1: 
!                 calculation of the Voigt profile by expicit convolution
      integer  iposLor,ipLG,i,ibg,j,ij,n
      logical  b_Lorentz,b_Gauss,b_gamnat,b_xsi,b_srw8,b_nLG,           &
               b_Gaussgt0,b_flag_Voigt,b_com,b_ipos        

      real     w_aLorentz,w_aGauss,wpi,dxc,xc,yc,vxy,dvxy,              &
               halpda1,halpda2,hbeta1,hbeta2,beta1,beta2,beta3,beta4,   &
               alpha1,alpha2,alpha3,alpha4,widthg,widthl2,width2,       &
               disp,hp,h0,h1                                            
      real, parameter:: a1=-1.2150,a2=-1.3509,b1= 1.2359,b2= 0.3786,    &
                        c1=-0.3085,c2= 0.5906,d1= 0.0210,d2=-1.1858,    &
                        d12=0.0105,d22=-0.5928,wln2=0.832554611
      complex  hc,hc1,hxsi 
                                             
!     write(6,'(2a,/,2l5,4f10.3,5i6)') 'LORGAU b_Lorentz,b_Gauss,', &  
!     'gamnat,w_Lorentz,w_Gauss,srw8,iflag_Voigt,nLG,ipLG',          & 
!     b_Lorentz,b_Gauss,gamnat,w_Lorentz,w_Gauss,srw8,               & 
!     iflag_Voigt,nLG,ipLG                          
                                                                         
      ipLG=ipos-6
      h0=gamnat/100. 
      h1=h0/100. 
      b_gamnat =abs(gamnat-real(array_fr(ipLG+1))).lt.h0 
      b_xsi    =abs(e_xsi-aimag(array_fr(ipLG+1))).lt.h0 
      b_Lorentz=abs(w_Lorentz-real(array_fr(ipLG+2))).lt.h0 
      b_Gauss  =abs(w_Gauss-aimag(array_fr(ipLG+2))).lt.h0 
      b_srw8   =abs(srw8-real(array_fr(ipLG+3))).lt.h1 
      b_nLG    =nLG  .eq.int(aimag(array_fr(ipLG+3))+0.01) 
      b_com=b_gamnat.and.b_xsi.and.b_Lorentz.and.b_Gauss.and.b_srw8.and.b_nLG
!     write(6,'(a,6f15.6)')' w_Lorentz,w_Gauss=',w_Lorentz,w_Gauss 
!     write(6,'(6f10.1)')(array_fr(ipLG+j),j=0,6) 
                                                                        
      b_flag_Voigt=iflag_Voigt.eq.int(aimag(array_fr(ipLG+4))+0.01) 
      b_ipos=ipos.eq.int(real(array_fr(ipLG+4))+0.01) 

      w_aLorentz=abs(w_Lorentz)+1. 
      w_aGauss=abs(w_Gauss) 
      b_Gaussgt0=w_aGauss.gt.0.01 
!     write(6,'(a,12L4)')'b_com,b_gamnat...=',             & 
!          b_gamnat,b_xsi,b_Lorentz,b_srw8,b_nLG,b_flag_Voigt,&
!          b_ipos,b_iposLor,b_Gaussgt0                     

!      if iflag_Voigt is not defined iflag_Voigt is =0 by default, so that the 
!      approximation is used and not the time consuming integration 
                                            
      if(iflag_Voigt.eq.0)then 
       if(b_Gaussgt0)then 
        if(.not.(b_com.and.b_flag_Voigt.and.b_ipos)) then 
!        Voigt profile according to A.B. McLean, C.E.J. Mitchell and    
!        D.M. Swantston, J.Electron Spectroscopy 69(1994)125-132        
         wpi=1.772453851/w_aLorentz 
         hxsi=cmplx(1.,2*e_xsi)*wpi 
         dxc=2.0*wln2*srw8/gamnat/w_aGauss 
         yc=wln2*w_aLorentz/w_aGauss 
         halpda1=c1*(yc-a1)-d1*b1 
         halpda2=c2*(yc-a2)-d2*b2 
         hbeta1=(yc-a1)**2 
         hbeta2=(yc-a2)**2 
         xc=-dxc 
         do  n=0,nLG 
          xc=xc+dxc 
          beta1=hbeta1+(xc-b1)**2 
          beta3=hbeta1+(xc+b1)**2 
          beta2=hbeta2+(xc-b2)**2 
          beta4=hbeta2+(xc+b2)**2 
          alpha1=(halpda1+d1*xc)/beta1 
          alpha3=(halpda1-d1*xc)/beta3 
          alpha2=(halpda2+d2*xc)/beta2 
          alpha4=(halpda2-d2*xc)/beta4 
          vxy=alpha1+alpha2+alpha3+alpha4 
          dvxy=( d12-alpha1*(xc-b1))/beta1+                             &
               (-d12-alpha3*(xc+b1))/beta3+                             &
               ( d22-alpha2*(xc-b2))/beta2+                             &
               (-d22-alpha4*(xc+b2))/beta4                              
           array_fr(ipos+n)=cmplx(xc*vxy+dvxy,yc*vxy)*hxsi 
         end do 
                                                                        
!        write(6,'(a)')'## iflag_Voigt.eq.0 &  b_Gaussgt0'               
         array_fr(ipLG+1)=cmplx(gamnat,e_xsi) 
         array_fr(ipLG+2)=cmplx(w_Lorentz,w_Gauss) 
         array_fr(ipLG+3)=cmplx(srw8,float(nLG)) 
         array_fr(ipLG+4)=cmplx(float(ipos),float(iflag_Voigt)) 
        end if 
       else 
!       Lorentz                                                         
        if(.not.(b_com.and.b_ipos)) then 
         widthL2=w_aLorentz*gamnat/2. 
         disp=srw8/widthL2 
         hp=-disp 
         hxsi=cmplx(1.,2*e_xsi)/w_aLorentz 
         do  n=0,nLG 
          hp=hp+disp 
          array_fr(ipos+n)=cmplx(hp,1.)/(1.0+hp*hp)*hxsi 
         end do 

!        write(6,'(a,i8,2L5)')' iflag_Voigt.eq.0 &  w_Gauss=0',ipLG,b_com,b_iposlor
         array_fr(ipLG+1)=cmplx(gamnat,e_xsi) 
         array_fr(ipLG+2)=cmplx(w_Lorentz,w_Gauss) 
         array_fr(ipLG+3)=cmplx(srw8,float(nLG)) 
         array_fr(ipLG+5)=cmplx(float(iposLor),float(iflag_Voigt)) 
        end if 
       end if 
      else if(iflag_Voigt.eq.1)then 
!      Lorentz curve is needed from 0 to nLG+mGa                        
        widthL2=w_aLorentz*gamnat/2. 
        disp=srw8/widthL2 
        hp=-disp 
        hxsi=cmplx(1.,2*e_xsi)/w_aLorentz 
        do  n=0,nLG+mGa 
         hp=hp+disp 
         aLOR(n)=cmplx(hp,1.)/(1.0+hp*hp)*hxsi 
        end do 

        widthG=w_aGauss*gamnat 
        ibg=(6.*widthG/srw8+1.)/2.    ! 0.0005 precission 
        ibg=2*ibg 
                                                                        
        if(ibg.gt.0) then 
         if(ibg.gt.mGa) ibg=mGa 
!        -ibg--------0--------ibg           Gauss                       
                                                                        
         width2=widthG/wln2/2.0  ! units of gamma natural  
         disp=srw8/width2 
         h0=-disp 
         do i=0,ibg+1 
          h0=h0+disp 
          Gauss(i)=exp(-h0**2) 
         end do 
          h1=0. 
         do j=1,ibg-1,2 
          h1=h1+ Gauss(j)*2. 
         end do 
         do j=2,ibg-2,2 
          h1=h1+ Gauss(j) 
         end do 
         h1=(h1*2.+Gauss(0)+Gauss(ibg))*2. 
         h1=2.*h1/3. 
         do i=0,ibg+1 
          Gauss(i)=Gauss(i)/h1 
         end do 
                                                                        
!        convolution with exp(-x**2/(sGgL*gamnat)**2)                   
!                                                                       
!        0------------------------------------nLG---nLor                
!                                       ibg----0----ibg                 
!        0------------------------------------nLG                       
!        this convolution is calculated with stepwidth srw8             
                                                                        
         do i=0,nLG 
          hc=(0.,0.) 
          do j=-ibg+1,-1,2 
           ij=i+j 
           if(ij.gt.0) then 
            hc=hc+Gauss(-j)*aLOR(ij)*2. 
           else 
            hc=hc-Gauss(-j)*conjg(aLOR(ij))*2. 
           end if 
          end do 
          do j=1,ibg-1,2 
           hc=hc+Gauss(j)*aLOR(i+j)*2. 
          end do 
          do j=-ibg+2,-2,2 
           ij=i+j 
           if(ij.gt.0) then 
            hc=hc+Gauss(-j)*aLOR(ij) 
           else 
            hc=hc-Gauss(-j)*conjg(aLOR(ij)) 
           end if 
          end do 
          do j=0,ibg-2,2 
           hc=hc+Gauss(j)*aLOR(i+j) 
          end do 
          ij=i-ibg 
          if(ij.gt.0) then 
           hc1=aLOR(ij) 
          else 
           hc1=-conjg(aLOR(ij)) 
          end if 
                                                                        
          hc=hc*2.+Gauss(ibg)*(hc1+aLOR(i+ibg)) 
!         cLG(i,iset)=cmplx(hr,hi)/3.                                   
          array_fr(ipos+i)=hc/1.5 
         end do 
        end if  ! if ibg >0  

!       write(6,'(a)')'end iflag_Voigt.eq.0 &  w_Gauss >0'               
        array_fr(ipLG+1)=cmplx(gamnat,e_xsi) 
        array_fr(ipLG+2)=cmplx(w_Lorentz,w_Gauss) 
        array_fr(ipLG+3)=cmplx(srw8,float(nLG)) 
        array_fr(ipLG+4)=cmplx(float(ipos),float(iflag_Voigt)) 
      end if ! iflag_Voigt=1 
                                                                        
!     If a Gauss broadening is used (simulating                         
!     a hyperfine field distribution), the sum of the Gauss function    
!     values (weighting factors)  has to be 1.                         
                                                                        
      return 
      END                                         


      subroutine cLORGAU(gamnat,e_xsi,srw8,w_Lorentz,w_Gauss,nLG,cLG)
      use comthe, only: array_fr
      implicit none 
!     version August 2013
!     calculation of the Lorentz-Gauss functions                        
      real,    intent(in) :: gamnat,e_xsi,srw8,w_Lorentz,w_Gauss 
      integer, intent(in) :: nLG
      complex, intent(out), dimension(0:nLG):: cLG        
 
      integer  n
      real     w_aLorentz,w_aGauss,wpi,dxc,xc,yc,vxy,dvxy,              &
               halpda1,halpda2,hbeta1,hbeta2,beta1,beta2,beta3,beta4,   &
               alpha1,alpha2,alpha3,alpha4,widthl2,      &
               disp,hp                                           
      real, parameter:: a1=-1.2150,a2=-1.3509,b1= 1.2359,b2= 0.3786,    &
                        c1=-0.3085,c2= 0.5906,d1= 0.0210,d2=-1.1858,    &
                        d12=0.0105,d22=-0.5928,wln2=0.832554611
      complex  hxsi 

      w_aLorentz=abs(w_Lorentz)+1. 
      w_aGauss=abs(w_Gauss) 
!      write(6,'(a,/,7x,5f10.2,i6)')'cLORGAU gamnat,e_xsi,srw8,w_Lorentz,w_Gauss,nLG=',&
!                               gamnat,e_xsi,srw8,w_Lorentz,w_Gauss,nLG

       if(w_aGauss.gt.0.01)then 
!       Voigt profile according to A.B. McLean, C.E.J. Mitchell and    
!       D.M. Swantston, J.Electron Spectroscopy 69(1994)125-132        
        wpi=1.772453851/w_aLorentz 
        hxsi=cmplx(1.,2*e_xsi)*wpi 
        dxc=2.0*wln2*srw8/gamnat/w_aGauss 
        yc=wln2*w_aLorentz/w_aGauss 
        halpda1=c1*(yc-a1)-d1*b1 
        halpda2=c2*(yc-a2)-d2*b2 
        hbeta1=(yc-a1)**2 
        hbeta2=(yc-a2)**2 
        xc=-dxc 
        do  n=0,nLG 
         xc=xc+dxc 
         beta1=hbeta1+(xc-b1)**2 
         beta3=hbeta1+(xc+b1)**2 
         beta2=hbeta2+(xc-b2)**2 
         beta4=hbeta2+(xc+b2)**2 
         alpha1=(halpda1+d1*xc)/beta1 
         alpha3=(halpda1-d1*xc)/beta3 
         alpha2=(halpda2+d2*xc)/beta2 
         alpha4=(halpda2-d2*xc)/beta4 
         vxy=alpha1+alpha2+alpha3+alpha4 
         dvxy=( d12-alpha1*(xc-b1))/beta1+                             &
              (-d12-alpha3*(xc+b1))/beta3+                             &
              ( d22-alpha2*(xc-b2))/beta2+                             &
              (-d22-alpha4*(xc+b2))/beta4                              
          cLG(n)=cmplx(xc*vxy+dvxy,yc*vxy)*hxsi 
        end do 
       else 
!       Lorentz                                                         
        widthL2=w_aLorentz*gamnat/2. 
        disp=srw8/widthL2 
        hp=-disp 
        hxsi=cmplx(1.,2*e_xsi)/w_aLorentz 
        do  n=0,nLG 
         hp=hp+disp 
         cLG(n)=cmplx(hp,1.)/(1.0+hp*hp)*hxsi 
        end do 
       end if 
                                                                        
!     If a Gauss broadening is used (simulating                         
!     a hyperfine field distribution), the sum of the Gauss function    
!     values (weighting factors) is 1.                         
                                                                        
      return 
      END                                           
                                                                        
                                                                        
     subroutine aLORGAU(Eagd,gamnat,e_xsi,srw,w_Lorentz,w_Gauss,iflag_Voigt,&
                         nLG,cLG)
     implicit none 
!    version August 2013
!    the position Eagd typically differs from cal to call, so that are no
!    parameter stored on array_fr
!    the result is written to cLG(-mLG:mLG)
!    LOR and Gauss arrays are cache memory

      real,    intent(in):: Eagd,gamnat,e_xsi,srw,w_Lorentz,w_Gauss 
      integer, intent(in):: nLG,iflag_Voigt
      complex, intent(out), dimension(-nLG:nLG):: cLG        
                                                                         
      real    w_aLorentz,w_aGauss,wpi,dxc,xc,yc,vxy,dvxy,              &
              halpda1,halpda2,hbeta1,hbeta2,beta1,beta2,beta3,beta4,   &
              alpha1,alpha2,alpha3,alpha4,widthg,widthl2,disp,hp,h0,h1  
      complex hc,hxsi
      integer   i,j,ibg,n,nLor 
      real, parameter:: a1=-1.2150,a2=-1.3509,b1= 1.2359,b2= 0.3786,    &
                        c1=-0.3085,c2= 0.5906,d1= 0.0210,d2=-1.1858,    &
                        d12=0.0105,d22=-0.5928,wln2=0.832554611

      complex, dimension(:), allocatable:: cLOR
      real,    dimension(:), allocatable:: Gauss
   
!      write(6,'(2a)')' aLORGAU:',&
!                     'Eagd,gamnat,srw,w_Lorentz,w_Gauss,iflag_Voigt,nLG'
!      write(6,'(f12.5,f8.4,f10.5,2f8.3,2x,i3,i6)') &                    
!                      Eagd,gamnat,srw,w_Lorentz,w_Gauss,iflag_Voigt,nLG 
                                                                        
!      1/(j*srw8-Eagd)+iG/2) =(j*srw8-Eagd)/(j*srw8-Eagd)**2+G**2/4)    
!                            -iG/2/(j*srw8-Eagd)**2+G**2/4)             
      w_aGauss=abs(w_Gauss) 
      w_aLorentz=abs(w_Lorentz)+1. 
                                                                        
      if(iflag_Voigt.eq.0) then 
                                                                        
       if(w_aGauss.lt.0.01) then   ! Lorentz 
        widthL2=w_aLorentz*gamnat/2. 
        disp=srw/widthL2 
        hp=-Eagd/widthL2-disp*float(nLG+1) 
        h1=-Eagd/widthL2
        do  n=0,nLG 
         hp=h1+disp*float(n) 
         cLG(n)=cmplx(hp,1.)/(1.0+hp*hp)/w_aLorentz 
         hp=h1-disp*float(n)
         cLG(-n)=cmplx(hp,1.)/(1.0+hp*hp)/w_aLorentz 
        end do 
!       write(6,'(a)') 'cLOR(n)='                                        
!       write(6,'(i4,2f12.3)') (n,cLG(n)*100.,n=-5,5)                   
       else 
!       Voigt profile according to A.B. McLean, C.E.J. Mitchell and     
!       D.M. Swantston, Queens's University, Kingston, Ontario, Canada  
                                                                        
        wpi=1.772453851/w_aLorentz 
        yc=wln2/w_aGauss*w_aLorentz 
        halpda1=c1*(yc-a1)-d1*b1 
        halpda2=c2*(yc-a2)-d2*b2 
        hbeta1=(yc-a1)**2 
        hbeta2=(yc-a2)**2 
                                                                        
        dxc=2.0*wln2*srw/gamnat/w_aGauss 
        xc=-2.0*wln2*Eagd/gamnat/w_aGauss-dxc*float(nLG+1) 
        do  n=-nLG,nLG 
         xc=xc+dxc 
         beta1=hbeta1+(xc-b1)**2 
         beta3=hbeta1+(xc+b1)**2 
         beta2=hbeta2+(xc-b2)**2 
         beta4=hbeta2+(xc+b2)**2 
         alpha1=(halpda1+d1*xc)/beta1 
         alpha3=(halpda1-d1*xc)/beta3 
         alpha2=(halpda2+d2*xc)/beta2 
         alpha4=(halpda2-d2*xc)/beta4 
         vxy=alpha1+alpha2+alpha3+alpha4 
         dvxy=( d12-alpha1*(xc-b1))/beta1+                              &
              (-d12-alpha3*(xc+b1))/beta3+                              &
              ( d22-alpha2*(xc-b2))/beta2+                              &
              (-d22-alpha4*(xc+b2))/beta4                               
          cLG(n)=cmplx(xc*vxy+dvxy,yc*vxy)*wpi 
        end do 
       end if 
       if(abs(e_xsi).gt.gamnat/100.) then 
        hxsi=cmplx(1.,2.*e_xsi) 
        do  n=-nLG,nLG 
         cLG(n)=cLG(n)*hxsi 
        end do 
       end if 
      else if(iflag_Voigt.eq.1) then 
                                                                        
       widthG=w_aGauss*gamnat 
       ibg=(6.*widthG/srw+1.)/2.  ! 0.0005 precission   
       ibg=2*ibg 
!      Gauss is always calculated for aLORGAU                           
       if(ibg.gt.nLG/3) ibg=nLG/3
                                                                        
       nLor=nLG+ibg 
       widthL2=w_aLorentz*gamnat/2. 
       disp=srw/widthL2 
       hp=-Eagd/widthL2-disp*float(nLor+1) 
                                                                        
!      convolution numerically                                          
!      Lorentz curve  with stepwidth (srw)                              
!                                                                       
!      -nLor-------------EAGD----------------nLor                     

       allocate(cLOR(-nLor:nLor),Gauss(0:ibg+1))
                                                                        
       do  n=-nLor,nLor 
        hp=hp+disp 
        cLOR(n)=cmplx(hp,1.)/(1.0+hp*hp)/w_aLorentz 
       end do 
                                                                        
                                                                        
       if(ibg.gt.0) then 
!        -ibg--------0--------ibg           Gauss                       
                                                                        
         disp=2.0*wln2*srw/widthG 
         h0=-disp 
         do i=0,ibg+1 
          h0=h0+disp 
          Gauss(i)=exp(-h0**2) 
         end do 
          h1=0. 
         do j=1,ibg-1,2 
          h1=h1+ Gauss(j)*2. 
         end do 
         do j=2,ibg-2,2 
          h1=h1+ Gauss(j) 
         end do 
         h1=(h1*2.+Gauss(0)+Gauss(ibg)) 
         h1=2.*h1/3. 
         do i=0,ibg+1 
          Gauss(i)=Gauss(i)/h1 
         end do 
                                                                        
                                                                        
!       convolution with exp(-x**2/(sGgL*gamnat)**2)                    
!                                                                       
!       0------------------------------------nLG---nLor                 
!                                     ibg----0----ibg                   
!       0------------------------------------nLG                        
!       this convolution is calculated with stepwidth srw8              
!       write(6,'(a,i4)')  ' ####aLORGAU igb=',ibg                     
         do i=-nLG,nLG 
          hc=(0.,0.) 
          do j=-ibg+1,-1,2 
            hc=hc+Gauss(-j)*cLOR(i+j)*2. 
          end do 
          do j=1,ibg-1,2 
           hc=hc+Gauss(j)*cLOR(i+j)*2. 
          end do 
          do j=-ibg+2,-2,2 
           hc=hc+Gauss(-j)*cLOR(i+j) 
          end do 
          do j=0,ibg-2,2 
           hc=hc+Gauss(j)*cLOR(i+j) 
          end do 
          hc=hc*2.+Gauss(ibg)*(cLOR(i-ibg)+cLOR(i+ibg)) 
          cLG(i)=hc/3. 
         end do 
       else
        do i=-nLG,nLG 
         cLG(i)=cLOR(i)
        end do 
       end if           ! if ibg >0  
       if(abs(e_xsi).gt.gamnat/100.) then 
        hxsi=cmplx(1.,2.*e_xsi) 
        do  n=-nLG,nLG 
         cLG(n)=cLG(n)*hxsi 
        end do 
       end if
       deallocate(cLOR,Gauss) 
      end if  ! convolution numerically    

      return 
      END                                           
